

local sx, sy, r, down, rect = 0, 0, 0, false, {}

function love.draw()

	love.graphics.setColor(255, 255, 255, 255)
	for i,v in ipairs(rect) do
		round_rectangle(v.x, v.y, v.width, v.height, v.radius)
	end
	
	if down then
		love.graphics.setColor(255, 255, 255, 126)
		local w = love.mouse.getX() - sx
		local h = love.mouse.getY() - sy
		if w > h then
			r = h / 4
		else
			r = w / 4
		end
		round_rectangle(sx, sy, w, h, r)
	end

end

function love.keypressed(key)
	if key == "escape" then love.event.push("quit") end
end

function love.mousepressed(x, y, key)
	if key == "l" then
		sx = x
		sy = y
		down = true
	end
end

function love.mousereleased(x, y, key)
	if key == "l" then
		rect[#rect + 1] = {
				x = sx,
				y = sy,
				width = x - sx,
				height = y - sy,
				radius = r
			}
		down = false
	end
end

function round_rectangle(x, y, width, height, radius)
	--RECTANGLES
	love.graphics.rectangle("fill", x + radius, y + radius, width - (radius * 2), height - radius * 2)
	love.graphics.rectangle("fill", x + radius, y, width - (radius * 2), radius)
	love.graphics.rectangle("fill", x + radius, y + height - radius, width - (radius * 2), radius)
	love.graphics.rectangle("fill", x, y + radius, radius, height - (radius * 2))
	love.graphics.rectangle("fill", x + (width - radius), y + radius, radius, height - (radius * 2))
	
	--ARCS
	love.graphics.arc("fill", x + radius, y + radius, radius, math.rad(-180), math.rad(-90))
	love.graphics.arc("fill", x + width - radius , y + radius, radius, math.rad(-90), math.rad(0))
	love.graphics.arc("fill", x + radius, y + height - radius, radius, math.rad(-180), math.rad(-270))
	love.graphics.arc("fill", x + width - radius , y + height - radius, radius, math.rad(0), math.rad(90))
end